"use strict";

//Student Object
function student(firstName, lastName, age, courses)
{
    this.firstName = firstName;
    this.lastName = lastName;
    this.age = age;
    this.courses = courses;

    //Student Methods
    this.addCourse = function(courseName)
    {
        this.courses.push(courseName);
    }
    this.removeCourse = function(courseName)
    {
        var index = courses.indexOf(courseName);
        if (index > -1)
        {
            courses.splice(index, 1);
        }
    }
    this.getInfo = function()
    {
        return this.firstName + " " + this.lastName + " " + this.age
    }

}

//Creating new Student Object
var student1 = new student("Lian", "Caraang", 22, ["Web Programming", "Database Design", "World Mythology"])

//Input Prompts
let courseName = prompt("Enter a course to add to this student's courses");
student1.addCourse(courseName); //Calling addCourse function to add course to the object

courseName = prompt("Enter a course to remove from this student's courses");
student1.removeCourse(courseName); //Calling removeCourse function to remove course to the object

//Display the object information
console.log(student1);

//Display the Student Information
alert(student1.getInfo());

//Calling the displayCourse function
displayCourse(student1);

//Display Course Function
function displayCourse(studentObj)
{
    console.log(studentObj.courses);
}

//Creating a Grades Array to Track the Instances 
var gradesArray = [];

//Grades Object to Track Grades
function grades(courseName, grade)
{
    this.courseName = courseName;
    this.grade = grade;
    gradesArray.push(this);
}

//New grade objects based on the courses
var course1 = new grades(student1.courses[0], "A")
var course2 = new grades(student1.courses[1], "B")
var course3 = new grades(student1.courses[2], "C")

//Call the displayGrades function using the array
displayGrades(gradesArray);

//Displaying the Grades Function
function displayGrades(courseGrades)
{
    for (let i in courseGrades)
    {
        console.log(courseGrades[i])
    }
}

//International Student Object Inheritating from the Student Object
let internationalStudent =
{
    __proto__ : student1,
    country: "Philippines"
}

//Call the Student Comparison Method
studentComparison(student1, internationalStudent)

//Comparing the Student Object and the International Student Object
function studentComparison(studentObj, internationalObj)
{
    if (studentObj.firstName == internationalObj.firstName && studentObj.lastName == internationalObj.lastName && studentObj.age == internationalObj.age)
    {
        console.log("They are the same student");
    }
    else
    {
        console.log("They are not the same student");
    }
}

